import "antd/es/form/style";
import _Form from "antd/es/form";
import "antd/es/card/style";
import _Card from "antd/es/card";

var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from "react";
import { isFn, isPromise } from "../utils/tool";
import renderOptions from "../lib/renderOptions";
import SButton from "./SButton";
import compMap from "../SCompMap/compMap";
var useState = React.useState;
var defaultItemWidth = {
  RangePicker: 400
};
export default function SFilter(_a) {
  var _b = _a.initialData,
      initialData = _b === void 0 ? {} : _b,
      filters = _a.filters,
      _c = _a.formProps,
      formProps = _c === void 0 ? {} : _c,
      searchBtnHandler = _a.searchBtnHandler,
      _d = _a.buttons,
      buttons = _d === void 0 ? [] : _d,
      formChange = _a.onChange,
      updateFormData = _a.updateFormData,
      searchLoading = _a.searchLoading;

  var _e = useState(__assign({}, initialData)),
      formData = _e[0],
      setFormData = _e[1];

  var _f = useState({}),
      itemChildren = _f[0],
      setItemChildren = _f[1];

  var requiredParams = [];

  var filterItemChange = function (v, key, onChange) {
    var _a;

    if (v && v.target) v = v.target.value;

    var res = __assign({}, formData, (_a = {}, _a[key] = v, _a));

    setFormData(res);
    updateFormData(res);
    if (isFn(onChange)) onChange(v);
    if (isFn(formChange)) formChange(res);
  };

  return React.createElement(_Card, null, React.createElement(_Form, __assign({
    layout: "inline"
  }, formProps), filters.map(function (_a) {
    var Comp = _a.Comp,
        _b = _a.type,
        type = _b === void 0 ? "Input" : _b,
        label = _a.label,
        key = _a.key,
        formItemProps = _a.formItemProps,
        render = _a.render,
        onChange = _a.onChange,
        options = _a.options,
        _c = _a.style,
        style = _c === void 0 ? {} : _c,
        props = _a.props,
        required = _a.required;
    if (required) requiredParams.push(key);
    style.width = defaultItemWidth[type] || 300;
    var Item = compMap[type];
    var Children = render && render();

    if (!options && isPromise(Children) && !itemChildren[key]) {
      Children.then(function (Child) {
        var _a;

        setItemChildren(__assign({}, itemChildren, (_a = {}, _a[key] = Child, _a)));
      }).catch(function (err) {
        console.log("get " + key + " options error :" + err);
      });
    }

    return Item ? React.createElement(_Form.Item, __assign({
      required: required,
      key: label,
      label: label
    }, formItemProps), Comp ? isFn(Comp) ? React.createElement(Comp, null) : Comp : React.createElement(Item, __assign({
      allowClear: !required,
      value: formData[key],
      onChange: function (e) {
        filterItemChange(e, key, onChange);
      },
      style: style
    }, props), options ? renderOptions(options) : isPromise(Children) ? itemChildren[key] : Children)) : null;
  }), React.createElement(_Form.Item, null, React.createElement(SButton, {
    handler: searchBtnHandler,
    label: "Search",
    type: "primary",
    loading: searchLoading,
    props: {
      htmlType: "submit"
    }
  }), buttons.map(function (_a) {
    var Comp = _a.Comp,
        label = _a.label,
        key = _a.key,
        rest = __rest(_a, ["Comp", "label", "key"]);

    if (Comp) {
      return isFn(Comp) ? React.createElement(Comp, {
        key: key
      }) : Comp;
    }

    return React.createElement(SButton, __assign({
      key: label,
      label: label
    }, rest));
  }))));
}