var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from "react";
var useState = React.useState,
    useEffect = React.useEffect;
import compMap from "../SCompMap/compMap";
import { isFn } from "../utils/tool";
export default function (filters, tableColumns, openModal) {
  var _a = useState([]),
      columns = _a[0],
      setColumns = _a[1];

  useEffect(function () {
    var res = [];
    filters.forEach(function (_a) {
      var label = _a.label,
          key = _a.key,
          _b = _a.inTable,
          inTable = _b === void 0 ? true : _b,
          tableRender = _a.tableRender;

      if (inTable) {
        res.push({
          title: label,
          dataIndex: key,
          key: key,
          render: tableRender
        });
      }
    });
    res = res.concat(tableColumns.map(function (_a) {
      var label = _a.label,
          key = _a.key,
          render = _a.render,
          modalRender = _a.modalRender,
          modalProps = _a.modalProps,
          type = _a.type,
          hide = _a.hide,
          rest = __rest(_a, ["label", "key", "render", "modalRender", "modalProps", "type", "hide"]);

      var Comp = compMap[type];

      if (Comp) {
        render = function (_text, record, _index) {
          if (isFn(hide) && hide(record)) return null;
          return React.createElement(Comp, __assign({
            onClick: function () {
              openModal(record, modalRender, modalProps);
            }
          }, rest));
        };

        key = label;
      }

      return {
        title: label,
        dataIndex: key,
        key: key,
        render: render
      };
    }));
    setColumns(res);
  }, [filters, tableColumns]);
  return columns;
}