import { isArr, isStr } from "./tool";
export function dealParams(obj) {
  Object.keys(obj).forEach(function (key) {
    var val = obj[key];
    if (isStr(val)) val = obj[key] = val.trim();
    if (!val && val !== 0) return delete obj[key];

    if (/time/.test(key) && val.format) {
      obj[key] = val.format("X");
    }

    return;
  });
  return obj;
}
export function dealRangePickerParams(opt) {
  return Object.entries(opt).reduce(function (acc, _a) {
    var key = _a[0],
        val = _a[1];

    if (/time/.test(key) && isArr(val)) {
      var beg = val[0],
          end = val[1];
      if (beg && beg._isAMomentObject) acc[key + "_beg"] = beg.format("X");
      if (end && end._isAMomentObject) acc[key + "_end"] = end.format("X");
    } else {
      acc[key] = val;
    }

    return acc;
  }, {});
}
export function getSPageParams(opt, isDealRangePicker) {
  if (isDealRangePicker === void 0) {
    isDealRangePicker = true;
  }

  if (isDealRangePicker) opt = dealRangePickerParams(opt);
  opt = dealParams(opt);
  return opt;
}
export function allRequired(opt, keys) {
  return keys.every(function (key) {
    return opt[key] || opt[key] === 0 || opt[key] === false;
  });
}