import * as React from "react";
import { Button } from "antd";
const { useState, useEffect } = React;
export default function SButton({
  label,
  type,
  handler,
  loading = false,
  props
}: any) {
  const [btnLoading, setBtnLoading] = useState(loading);
  useEffect(() => {
    setBtnLoading(loading);
  }, [loading]);
  const clickHandler = async () => {
    if (!handler) return;
    try {
      setBtnLoading(true);
      await handler();
    } finally {
      setBtnLoading(false);
    }
  };
  return (
    <Button loading={btnLoading} onClick={clickHandler} type={type} {...props}>
      {label}
    </Button>
  );
}
