import * as React from "react";
import { Table, Card } from "antd";
export default function STable({
  tableData = [],
  tableColumns,
  tableProps = {},
  pageNum = 1,
  pageSize = 10,
  totalNum = 0,
  pageChange,
  loading
}: any) {
  return (
    <Card style={{ marginTop: 20 }}>
      <Table
        loading={loading}
        rowKey={tableProps.rowKey}
        dataSource={tableData}
        columns={tableColumns}
        pagination={{
          current: pageNum,
          pageSize: pageSize,
          total: totalNum,
          onChange: pageChange,
          showTotal: (total: number, range: number[]) =>
            `${range[0]}-${range[1]} of ${total} items`
        }}
        {...tableProps}
      />
    </Card>
  );
}
