import * as React from "react";
const { useState, useEffect } = React;
import compMap from "../SCompMap/compMap";
import { isFn } from "../utils/tool";
export default function(filters: [], tableColumns: [], openModal: Function) {
  const [columns, setColumns] = useState([]);
  useEffect(() => {
    let res: any = [];
    filters.forEach(({ label, key, inTable = true, tableRender }: any) => {
      if (inTable) {
        res.push({
          title: label,
          dataIndex: key,
          key,
          render: tableRender
        });
      }
    });
    res = res.concat(
      tableColumns.map(
        ({
          label,
          key,
          render,
          modalRender,
          modalProps,
          type,
          hide,
          ...rest
        }: any) => {
          const Comp = compMap[type];
          if (Comp) {
            render = (_text: any, record: any, _index: number) => {
              if (isFn(hide) && hide(record)) return null;
              return (
                <Comp
                  onClick={() => {
                    openModal(record, modalRender, modalProps);
                  }}
                  {...rest}
                />
              );
            };
            key = label;
          }
          return {
            title: label,
            dataIndex: key,
            key,
            render
          };
        }
      )
    );
    setColumns(res);
  }, [filters, tableColumns]);
  return columns;
}
