import { isArr, isStr } from "./tool";
export function dealParams(obj: object): any {
  Object.keys(obj).forEach(key => {
    let val = obj[key];
    if (isStr(val)) val = obj[key] = val.trim();
    if (!val && val !== 0) return delete obj[key];
    if (/time/.test(key) && val.format) {
      obj[key] = val.format("X");
    }
    return;
  });
  return obj;
}
export function dealRangePickerParams(opt: any) {
  return Object.entries(opt).reduce((acc: any, [key, val]: any) => {
    if (/time/.test(key) && isArr(val)) {
      const [beg, end] = val;
      if (beg && beg._isAMomentObject) acc[key + "_beg"] = beg.format("X");
      if (end && end._isAMomentObject) acc[key + "_end"] = end.format("X");
    } else {
      acc[key] = val;
    }
    return acc;
  }, {});
}
export function getSPageParams(opt: any, isDealRangePicker: boolean = true) {
  if (isDealRangePicker) opt = dealRangePickerParams(opt);
  opt = dealParams(opt);
  return opt;
}
export function allRequired(opt: object, keys: string[]): boolean {
  return keys.every(key => opt[key] || opt[key] === 0 || opt[key] === false);
}
